"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Definition_1 = require("../metadata/Definition");
const definition_1 = require("graphql/type/definition");
/**
 * Metadata for GraphQLType object.
 */
class GraphQLTypeIndex extends Definition_1.Definition {
    constructor(config) {
        const configs = {
            definitionClass: config.definitionClass,
            definitionName: config.typeInstance.name,
            typeInstance: config.typeInstance,
        };
        super(configs);
    }
    get definitionName() { return this.config.definitionName; }
    isOutputType() { return definition_1.isOutputType(this.config.typeInstance); }
    isInputType() { return definition_1.isInputType(this.config.typeInstance); }
    buildTypeInstance() {
        return this.config.typeInstance;
    }
}
exports.GraphQLTypeIndex = GraphQLTypeIndex;
//# sourceMappingURL=GraphQLTypeIndex.js.map