import { GraphQLInputFieldConfig, GraphQLInputFieldConfigMap, GraphQLInputObjectType } from 'graphql';
import { Definition, DefinitionConfig, DefinitionKind } from '../metadata/Definition';
import { InputField } from '../reference/InputField';
import { TypeResolvingContext } from '../type-expression/types';
import { defaultInputFieldInstantiator } from '../types';
export interface InputTypeConfig extends DefinitionConfig {
}
/**
 * Metadata type for InputObjectType
 */
export declare class InputType<T extends InputTypeConfig = InputTypeConfig> extends Definition<T> {
    readonly kind: DefinitionKind;
    buildTypeInstance(context: TypeResolvingContext): GraphQLInputObjectType;
    protected buildInputFieldConfigMap(context: TypeResolvingContext): GraphQLInputFieldConfigMap;
    protected buildInputFieldConfig(context: TypeResolvingContext, field: InputField): GraphQLInputFieldConfig;
    protected instantiationCache: WeakMap<object, any>;
    buildInstantiator(context: TypeResolvingContext): typeof defaultInputFieldInstantiator;
}
//# sourceMappingURL=InputType.d.ts.map