import { GraphQLFieldConfig, GraphQLFieldConfigMap, GraphQLInterfaceType, GraphQLTypeResolver } from 'graphql';
import { Definition, DefinitionConfig, DefinitionKind } from '../metadata/Definition';
import { Field } from '../reference/Field';
import { TypeResolvingContext } from '../type-expression/types';
export interface InterfaceTypeConfig extends DefinitionConfig {
    resolveType?: GraphQLTypeResolver<any, any>;
    description?: string;
}
/**
 * Metadata type for InterfaceType
 */
export declare class InterfaceType<T extends InterfaceTypeConfig = InterfaceTypeConfig> extends Definition<T> {
    readonly kind: DefinitionKind;
    protected buildFieldConfig(context: TypeResolvingContext, field: Field): GraphQLFieldConfig<any, any>;
    protected buildFieldConfigMap(context: TypeResolvingContext): GraphQLFieldConfigMap<any, any>;
    buildTypeInstance(context: TypeResolvingContext): GraphQLInterfaceType;
}
//# sourceMappingURL=InterfaceType.d.ts.map