import { GraphQLFieldConfig, GraphQLFieldConfigMap, GraphQLInterfaceType, GraphQLObjectType } from 'graphql';
import { Definition, DefinitionConfig, DefinitionKind } from '../metadata/Definition';
import { Field } from '../reference/Field';
import { TypeResolvingContext } from '../type-expression/types';
export interface ObjectTypeConfig extends DefinitionConfig {
    description?: string;
}
/**
 * Metadata type for ObjectType
 */
export declare class ObjectType<TConfig extends ObjectTypeConfig = ObjectTypeConfig> extends Definition<TConfig> {
    readonly kind: DefinitionKind;
    /**
     * Build GraphQLObjectType instance from metadata.
     */
    buildTypeInstance(context: TypeResolvingContext): GraphQLObjectType;
    protected buildFieldConfigMap(context: TypeResolvingContext): GraphQLFieldConfigMap<any, any>;
    protected buildFieldConfig(context: TypeResolvingContext, field: Field): GraphQLFieldConfig<any, any>;
    protected findInterfaces(context: TypeResolvingContext): GraphQLInterfaceType[];
    protected buildIsTypeOf(context: TypeResolvingContext): (source: any) => boolean;
}
//# sourceMappingURL=ObjectType.d.ts.map