"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const ObjectType_1 = require("./ObjectType");
const SubscriptionType_1 = require("./SubscriptionType");
/**
 * Fallback class for Query type.
 *
 * It can be overridden by defining custom Query class with [defineType] decorator
 */
class Query {
}
exports.Query = Query;
/**
 * Fallback class for Mutation type.
 *
 * It can be overridden by defining custom Mutation class with [defineType] decorator
 */
class Mutation {
}
exports.Mutation = Mutation;
/**
 * Fallback class for Subscription type.
 *
 * It can be overridden by defining custom Mutation class with [defineType] decorator
 */
class Subscription {
}
exports.Subscription = Subscription;
function loadFallbackRootTypes(storage) {
    storage.registerMetadata([
        new ObjectType_1.ObjectType({
            definitionClass: Query,
            definitionName: 'Query'
        }),
        new ObjectType_1.ObjectType({
            definitionClass: Mutation,
            definitionName: 'Mutation'
        }),
        new SubscriptionType_1.SubscriptionType({
            definitionClass: Subscription,
            definitionName: 'Subscription',
        })
    ]);
}
exports.loadFallbackRootTypes = loadFallbackRootTypes;
//# sourceMappingURL=rootTypes.js.map