import { DefinitionKind } from './metadata/Definition';
import { MetadataStorage } from './metadata/MetadataStorage';
import { DefinitionParser } from './sdl/ast';
import { TypeExpression } from './type-expression/TypeExpression';
import { Thunk } from './types';
import { TypeArg } from './type-expression/types';
/**
 * Create a new MetadataStorage initialized with default metadata
 */
export declare function createMetadataStorage(): MetadataStorage;
/**
 * Global MetadataStorage used by default.
 */
export declare let globalMetadataStorage: MetadataStorage;
export declare function getGlobalMetadataStorage(): MetadataStorage;
/**
 * Get a GraphQLType instance from the given storage or default
 * global metadata storage.
 * @param typeArg
 * @param storage
 */
export declare function getType(typeArg: TypeExpression | TypeArg, kind?: DefinitionKind): any;
/**
 * Define a type linked to decorated class and add it to the given
 * storage or default global metadata storage.
 * @param metadataOrThunk
 */
export declare function defineType(parsersOrThunk: DefinitionParser[] | Thunk<DefinitionParser[]>): <T extends Object>(definitionClass: T) => T;
//# sourceMappingURL=global.d.ts.map