import { GraphQLFieldConfigArgumentMap, GraphQLFieldResolver } from 'graphql';
import { InputField } from './InputField';
import { Reference, ReferenceConfig } from '../metadata/Reference';
import { TypeResolvingContext } from '../type-expression/types';
export interface FieldConfig extends ReferenceConfig {
    fieldName: string;
    args: InputField[];
    description?: string;
    deprecationReason?: string;
    directives?: any;
    resolver: GraphQLFieldResolver<any, any>;
}
export declare class Field<TConfig extends FieldConfig = FieldConfig> extends Reference<TConfig> {
    protected readonly kind: 'output';
    readonly fieldName: string;
    readonly description: string | undefined;
    readonly deprecationReason: string | undefined;
    readonly resolver: GraphQLFieldResolver<any, any, {
        [argName: string]: any;
    }>;
    buildArgumentMap(context: TypeResolvingContext): GraphQLFieldConfigArgumentMap;
    buildResolver(context: TypeResolvingContext): GraphQLFieldResolver<any, any>;
}
//# sourceMappingURL=Field.d.ts.map