import { DefinitionNode, FieldDefinitionNode, InputObjectTypeDefinitionNode, InputValueDefinitionNode, InterfaceTypeDefinitionNode, ListTypeNode, NamedTypeNode, NonNullTypeNode, ObjectTypeDefinitionNode, ObjectTypeExtensionNode, InterfaceTypeExtensionNode, InputObjectTypeExtensionNode, DirectiveNode, ArgumentNode, ObjectFieldNode, ValueNode } from 'graphql';
import { Metadata } from '../metadata/MetadataStorage';
import { GraphQLFieldResolver } from 'graphql/type/definition';
import { TypeExpression } from '../type-expression/TypeExpression';
import { InputField } from '../reference/InputField';
import { TypeArg } from '../type-expression/types';
import { ResolverMap } from '../types';
export interface SubstitutionMap {
    [tempName: string]: TypeExpression | TypeArg;
}
export declare class DefinitionParser {
    protected rootNode: DefinitionNode;
    protected subsMap: SubstitutionMap;
    private metadata;
    constructor(rootNode: DefinitionNode, subsMap: SubstitutionMap);
    parseWithResolverMap(definitionClass: ResolverMap): Metadata[];
    protected completeTypeExpression(typeNode: NamedTypeNode | ListTypeNode | NonNullTypeNode): TypeExpression;
    protected handleObjectTypeDefinition(rootNode: ObjectTypeDefinitionNode, definitionClass: ResolverMap): void;
    protected handleObjectTypeExtension(rootNode: ObjectTypeExtensionNode, definitionClass: ResolverMap): void;
    protected handleInterfaceTypeDefinition(rootNode: InterfaceTypeDefinitionNode, definitionClass: ResolverMap): void;
    protected handleInterfaceTypeExtension(rootNode: InterfaceTypeExtensionNode, definitionClass: ResolverMap): void;
    protected handleInputObjectTypeDefinition(node: InputObjectTypeDefinitionNode, definitionClass: ResolverMap): void;
    protected handleInputObjectExtension(node: InputObjectTypeExtensionNode, definitionClass: ResolverMap): void;
    protected appendFieldMetadataConfig(node: FieldDefinitionNode, definitionClass: ResolverMap, extendingTypeName?: string): void;
    protected createInputField(node: InputValueDefinitionNode, definitionClass: ResolverMap, extendingTypeName?: string): InputField;
    protected appendInputFieldMetadataConfig(node: InputValueDefinitionNode, definitionClass: ResolverMap, extendingTypeName?: string): void;
    protected appendImplementTypeExpression(node: NamedTypeNode, definitionClass: ResolverMap, extendingTypeName?: string): void;
    protected completeDirectives(directiveNodes: ReadonlyArray<DirectiveNode>): DirectiveMap;
    protected completeArgumentsOrObjectFields(nodes: ReadonlyArray<ArgumentNode | ObjectFieldNode>): any;
    protected completeValueNode(node: ValueNode): any;
}
export declare type DirectiveMap = {
    [key: string]: any;
};
export declare function bindStaticResolver(definitionClass: ResolverMap, fieldName: string): GraphQLFieldResolver<any, any> | null;
//# sourceMappingURL=ast.d.ts.map