"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const graphql_1 = require("graphql");
const ast_1 = require("./ast");
const SUBSTITUTION_PREFIX = '__GIRIN__SUBS__';
function gql(strings, ...interpolated) {
    const result = [strings[0]];
    const subsMap = {};
    for (let i = 0; i < interpolated.length; i++) {
        const item = interpolated[i];
        let name;
        if (typeof item === 'string') {
            name = item;
        }
        else {
            name = `${SUBSTITUTION_PREFIX}${i}`;
            subsMap[name] = item;
        }
        result.push(name);
        result.push(strings[i + 1]);
    }
    const ast = graphql_1.parse(result.join(''));
    return ast.definitions.map(rootNode => new ast_1.DefinitionParser(rootNode, subsMap));
}
exports.gql = gql;
//# sourceMappingURL=gql.js.map