"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const types_1 = require("../types");
const TypeExpression_1 = require("./TypeExpression");
const definition_1 = require("graphql/type/definition");
class GraphQLTypeExpression extends TypeExpression_1.TypeExpression {
    constructor(typeInstance) {
        super();
        this.typeInstance = typeInstance;
    }
    getTypeName() {
        const { typeInstance } = this;
        if (definition_1.isNamedType(typeInstance)) {
            return typeInstance.name;
        }
        else {
            throw new Error(`Cannot resolve name: ${typeInstance} is not a GraphQLNamedType`);
        }
    }
    getType() {
        return this.typeInstance;
    }
    getInstantiator() {
        return types_1.defaultInputFieldInstantiator;
    }
}
exports.GraphQLTypeExpression = GraphQLTypeExpression;
//# sourceMappingURL=GraphQLTypeExpression.js.map