"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const graphql_1 = require("graphql");
const TypeExpression_1 = require("./TypeExpression");
const GraphQLTypeExpression_1 = require("./GraphQLTypeExpression");
const DefinitionTypeExpression_1 = require("./DefinitionTypeExpression");
const formatObjectInfo_1 = require("../utilities/formatObjectInfo");
/**
 * Coerce the given argument to a [TypeExpression]
 * @param arg
 */
function coerceType(arg) {
    if (arg instanceof TypeExpression_1.TypeExpression) {
        return arg;
    }
    if (graphql_1.isType(arg)) {
        return new GraphQLTypeExpression_1.GraphQLTypeExpression(arg);
    }
    if (arg instanceof Function || typeof arg === 'string' || arg instanceof Object) {
        return new DefinitionTypeExpression_1.DefinitionTypeExpression(arg);
    }
    throw new Error(`Cannot coerce argument to type: ${formatObjectInfo_1.formatObjectInfo(arg)}`);
}
exports.coerceType = coerceType;
//# sourceMappingURL=coerceType.js.map