"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class PathMap {
    constructor() {
        this.children = new Map();
    }
    get(path) {
        let submap = this;
        for (let i = 0; i < path.length; i++) {
            const item = submap.children.get(path[i]);
            if (item === undefined) {
                return undefined;
            }
            else {
                submap = item;
            }
        }
        return submap.value;
    }
    set(path, value) {
        let submap = this;
        for (let i = 0; i < path.length; i++) {
            let item = submap.children.get(path[i]);
            if (item === undefined) {
                item = new PathMap();
                submap.children.set(path[i], item);
                submap = item;
            }
            else {
                submap = item;
            }
        }
        submap.value = value;
    }
}
exports.PathMap = PathMap;
//# sourceMappingURL=PathMap.js.map