import { GraphQLResolveInfo } from 'graphql';
/**
 * Class-based resolver context
 */
export declare class ResolverContext<TSource = undefined, TContext = any> {
    $env: IArguments;
    readonly $source: TSource;
    readonly $context: TContext;
    readonly $info: GraphQLResolveInfo;
    constructor(_base: TSource, _context?: TContext, _info?: GraphQLResolveInfo);
}
/**
 * Decorator for fields resolved from source directly
 * @param fieldName
 */
export declare function source(fieldName?: string): (prototype: {
    $source: any;
}, propertyKey: string) => void;
/**
 * Decorator for field resolved after async fetching
 * prototype should have `$fetch()` method which returns a Promise
 * @param fieldName
 */
export declare function lazy(fieldName?: string): (prototype: {
    $fetch: () => Promise<any>;
}, propertyKey: string) => void;
//# sourceMappingURL=ResolverContext.d.ts.map